"{ Package: 'stx:goodies/petitparser/compiler' }"

"{ NameSpace: Smalltalk }"

PPCConfiguration subclass:#PPCTokenizingConfiguration
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'PetitCompiler-Core'
!

!PPCTokenizingConfiguration methodsFor:'accessing - defaults'!

defaultParserSuperclass
    ^ PPTokenizingCompiledParser

    "Modified (comment): / 01-09-2015 / 08:48:03 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!PPCTokenizingConfiguration methodsFor:'compiling'!

invokePhases

    self runPass: PPCTokenDetector.

    context options cacheFirstFollow ifTrue:[
        self runPass: PPCCacheFirstFollowPass  
    ].  
    self runPass: PPCLL1Visitor.
    context options tokenize ifTrue:[
        self runPass: PPCTokenizingVisitor    
    ].

    self runPass: PPCMergingVisitor .

    context options specialize ifTrue:[
        self runPass: PPCSpecializingVisitor
    ].

    self runPass: PPCRecognizerComponentDetector .

    context options specialize ifTrue:[
        self runPass: PPCSpecializingVisitor
    ].
    context options inline ifTrue:[
        self runPass: PPCInliningVisitor     
    ]. 

    self runPass: PPCMergingVisitor .

    self runPass: PPCCheckingVisitor.
    context options cacheFirstFollow ifTrue:[
        self runPass: PPCCacheFirstFollowPass  
    ].  
    self runPass: PPCTokenizingCodeGenerator.
    self runPass: PPCFSAVisitor.
    self runPass: PPCTokenCodeGenerator.
    self runPass: PPCScannerCodeGenerator.  

    self generateScanner.
    self generateParser.

    "Modified: / 04-09-2015 / 10:25:00 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

